'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.actionwareReducer = actionwareReducer;

var _stateKeeper = require('./stateKeeper');

var _constants = require('./constants');

var _types = require('./types');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function actionwareReducer() {
  var _extends2, _extends3, _extends4;

  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments[1];

  var type = action.type;
  var payload = action.payload;
  var trackedAction = action.trackedAction;

  if (!trackedAction) return state;

  var nextState = state;

  if (type.endsWith(_constants.ERROR_TYPE_SUFFIX)) nextState = _extends({}, state, (_extends2 = {}, _defineProperty(_extends2, trackedAction._errorType, payload), _defineProperty(_extends2, trackedAction._busyType, false), _extends2));else if (type.endsWith(_constants.BUSY_TYPE_SUFFIX)) nextState = _extends({}, state, (_extends3 = {}, _defineProperty(_extends3, trackedAction._errorType, null), _defineProperty(_extends3, trackedAction._busyType, true), _extends3));else nextState = _extends({}, state, (_extends4 = {}, _defineProperty(_extends4, trackedAction._errorType, null), _defineProperty(_extends4, trackedAction._busyType, false), _extends4));

  (0, _stateKeeper.saveState)(nextState);

  return nextState;
}