'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mockNextWith = mockNextWith;
exports.addWaiter = addWaiter;
exports.resolveWaiters = resolveWaiters;
exports.rejectWaiters = rejectWaiters;
exports.next = next;

var _types = require('./types');

var _nextMock = null;

function mockNextWith(waiterMock) {
  _nextMock = waiterMock;
}

function addWaiter(action, promiseCallbacks) {
  action._waiters = action._waiters || [];
  action._waiters.push(promiseCallbacks);
}

function resolveWaiters(action, payload) {
  var waiters = action._waiters || [];
  waiters.forEach(function (it) {
    return it.resolve(payload);
  });
  action._waiters = [];
}

function rejectWaiters(action, error) {
  var waiters = action._waiters || [];
  waiters.forEach(function (it) {
    return it.reject(error);
  });
  action._waiters = [];
}

function next(action) {
  if (_nextMock) return _nextMock(action);

  return new Promise(function (resolve, reject) {
    addWaiter(action, { resolve: resolve, reject: reject });
  });
}